# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/spi/spi-cadence.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Cadence SPI controller

maintainers:
  - Michal Simek <michal.simek@amd.com>

allOf:
  - $ref: spi-controller.yaml#

properties:
  compatible:
    oneOf:
      - enum:
          - xlnx,zynq-spi-r1p6
      - items:
          - enum:
              - xlnx,zynqmp-spi-r1p6
              - xlnx,versal-net-spi-r1p6
              - cix,sky1-spi-r1p6
          - const: cdns,spi-r1p6

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  clock-names:
    items:
      - const: ref_clk
      - const: pclk

  clocks:
    maxItems: 2

  num-cs:
    description: |
      Number of chip selects used. If a decoder is used,
      this will be the number of chip selects after the
      decoder.
    $ref: /schemas/types.yaml#/definitions/uint32
    minimum: 1
    maximum: 4
    default: 4

  is-decoded-cs:
    description: |
      Flag to indicate whether decoder is used or not.
    $ref: /schemas/types.yaml#/definitions/uint32
    enum: [ 0, 1 ]
    default: 0

  power-domains:
    maxItems: 1

  label:
    description: Descriptive name of the SPI controller.

  resets:
    maxItems: 1

  reset-names:
    items:
      - const: spi

required:
  - compatible
  - reg
  - interrupts
  - clock-names
  - clocks

unevaluatedProperties: false

examples:
  - |
    spi@e0007000 {
      compatible = "xlnx,zynq-spi-r1p6";
      clock-names = "ref_clk", "pclk";
      clocks = <&clkc 26>, <&clkc 35>;
      interrupt-parent = <&intc>;
      interrupts = <0 49 4>;
      num-cs = <4>;
      is-decoded-cs = <0>;
      reg = <0xe0007000 0x1000>;
    };
...
